/* -*-mode: c++; coding: iso-8859-2-unix; -*- */

#ifndef _LARRAY_H_
#define _LARRAY_H_

#include <lcl.h>

#include <malloc.h>
#include <string.h>

class LCL_EXPORT LString;

/*!
 * \class LArray
 * \bug This class should never ever be used again!!! It will only work for c-types and is depricated!
 * \warning This class should never ever be used again!!! 
 * \depricated This class should never ever be used again!!!! Is is replaced by the class LTable which is implemented as LArray should be! So use LTable instead!!! LArray will be removed in future releases of the LCL!
 */

template <class Type>
class LCL_EXPORT LArray {
  friend class LString;

 protected:
  unsigned long items;
  Type * array;

  LArray & operator = ( LArray const & p1);
	
 public:
  LArray ();
  LArray ( unsigned long );
  LArray ( LArray<Type> const & );
  LArray ( const Type *, unsigned long );

  ~LArray ();

  void grow ( long );
  void resize ( unsigned long );

  bool operator == ( LArray<Type> const & ) const;

  void clear ();
  void append ( const Type *, unsigned long );
  void append ( Type const & );

  void set ( const Type *, unsigned long );

  unsigned long sizeOfElement () const;
  unsigned long size () const;
  unsigned long elements () const;

  void makeZero ();
  int forEach ( void (*iter)(int, Type *) );

  unsigned long contains ( Type const & ) const;

  Type const & get ( unsigned long ) const;
};

template <class Type>
LArray<Type>::LArray () :
  items ( 0 ), array ( NULL )
{
}

template <class Type>
LArray<Type>::LArray ( unsigned long _items ) :
  items ( 0 ), array ( NULL )
{  
  resize ( _items );
}

template <class Type>
LArray<Type>::LArray ( LArray const & p1 ) :
  items ( 0 ), array ( NULL )
{
  set ( p1.array, p1.items );
}

template <class Type>
LArray<Type>::LArray ( const Type * p1, unsigned long elems ) :
  items ( 0 ), array ( NULL )
{
  set ( p1, elems );
}

template <class Type>
LArray<Type>::~LArray ()
{
  //  clear();
  if ( array )
    free ( array );
}

template <class Type>
LArray<Type> & LArray<Type>::operator = ( LArray const & p1)
{
  //  clear ();
  /*  if ( items && p1.items ) {
    resize ( p1.items );
    memcpy ( array, p1.array, items );
    }*/
  set ( p1.array, p1.items );
  return *this;
}


template <class Type>
void LArray<Type>::append ( const Type * ptr, unsigned long _items )
{
  if ( (ptr == NULL) || (_items==0) )
    return;

  unsigned long oldItems = items;

  grow ( _items );

  Type * newptr = array;
  memcpy ( &newptr[oldItems], ptr, _items*sizeof(Type) );
  //  newptr += (oldItems);
  /*
  for (int x = 0; x < _items; x++)
    {
      newptr[x+oldItems] = ptr[x];
    }   
  */
}

template <class Type>
void LArray<Type>::append ( Type const & singleItem )
{
  append ( &singleItem, 1 );
}

template <class Type>
unsigned long LArray<Type>::contains ( Type const & findItem ) const
{
  unsigned long l, counter=0;

  for ( l=0; l<items; l++ ) {
    if ( get(l) == findItem )
      counter++;
  }

  return counter;
}

template <class Type>
void LArray<Type>::clear ()
{
  if ( array )
    free ( array );
  array = NULL;
  items = 0;
}

template <class Type>
void LArray<Type>::resize ( unsigned long _items )
{
  items = _items;
  array = (Type*) realloc ( array, size() );
}

template <class Type>
void LArray<Type>::grow ( long l )
{
  resize ( items + l );
}

template <class Type>
unsigned long LArray<Type>::sizeOfElement () const
{
  return sizeof ( Type );
}

template <class Type>
unsigned long LArray<Type>::elements () const
{
  return items;
}

template <class Type>
unsigned long LArray<Type>::size () const
{
  return items * sizeof(Type);
}

template <class Type>
bool LArray<Type>::operator == ( LArray<Type> const & p1 ) const
{
  if ( size() != p1.size() )
    return false;

  if ( (array == NULL) && (p1.array==NULL) )
    return true;

  if ( (array == NULL) || (p1.array==NULL) )
    return false;

  return memcmp ( array, p1.array, size() ) == 0;
}

template <class Type>
void LArray<Type>::set ( const Type * ptr, unsigned long elems )
{
  if ( elems == items )
    {
      memcpy ( array, ptr, elems*sizeof(Type) );
    }
  else
    {
      clear ();
      append ( ptr, elems );
    }
}

template <class Type>
Type const & LArray<Type>::get ( unsigned long pos ) const
{
  if ( (array==NULL) || (pos>=items) ) {
    throw 0;
    MSTHROW(Type);
  } else {
    return array[pos];
  }
}

template <class Type>
void LArray<Type>::makeZero ()
{
  memset ( array, 0, size() );
}

template <class Type>
int LArray<Type>::forEach ( void (*func)(int, Type *) )
{
    int x;
    for (x = 0; x < items; x++)
    {
        (*func)(x, &array[x]);
    }
    return(x);
}

#include <lcl/lstring.h>

#endif

