/* -*-mode: c++; coding: iso-8859-2-unix; -*- */

/* LCL - The Linux Class Library
 * Copyright (C) 1998-2002 Jens Reimann
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef _LCL_CMD_LINE_H_
#define _LCL_CMD_LINE_H_

#include <lcl.h>
#include <lcl/lstring.h>
#include <lcl/liostream.h>

class LCL_EXPORT LCommandLineInfoClass {
protected:
public:
  LCommandLineInfoClass ( char const *short_param, char const * long_param, bool has_data, char const * desc );
};

#define LCMDARG(sp,lp,hd,de) LCommandLineInfoClass cmdparam_##sp ( #sp, #lp, hd, de )
#define LCMDARG_SHORT(sp,hd,de) LCommandLineInfoClass cmdparam_##sp ( #sp, NULL, hd, de )
#define LCMDARG_LONG(sp_tag,lp,hd,de) LCommandLineInfoClass cmdparam_##sp_tag ( "", #lp, hd, de )

class LCL_EXPORT LCommandLine {
protected:
  LHash<LString,LString> parameters;
  LHeap<LString> fileList;
  LString appName;

public:
  LCommandLine ( );
  virtual ~LCommandLine ();

  void init ( int argc, char * argv [] );

  bool isSet ( LString const & param ) const;
  bool hasData ( LString const & param ) const;
  LString getData ( LString const & param, LString const & _default = "" ) const;
  LHeap<LString> getFileList () const;
  LString getAppName () const;
  LHash<LString,LString> getParameters () const;

  static void showHelp ( LOStream & outs );
};

#endif

