/* -*-mode: c++; coding: iso-8859-2-unix; -*- */

/* ****************************************************************************
   |      File: lconfobj.h
   |      Contains: class definition for LConfigObject
   |      Created: 18.03.1998
   |      Last Changed: 18.03.1998
   |      Version: 0.0
   |         
   |      ToDo: + just started
   |
   ************************************************************************* */

/* ====>> See also the ChangeLog in lconfobj.cc <<==== */

#ifndef _L_CONFOBJ_H_
#define _L_CONFOBJ_H_

class LConfigObject;

#include <lcl.h>
#include <lcl/lobject.h>
#include <lcl/lstring.h>
#include <lcl/lhash.h>

class LCL_EXPORT LConfigObject : public LObject {

 protected:
  LString type;
  LHash <LString,LString> dict;

 public:
  static bool warn;

  LConfigObject ( ); //!< Construct an empty object
  LConfigObject ( LString const & type );
  LConfigObject ( LConfigObject const & );
  
  LString get ( LString const & key, LString const & = LString() ) const;
  bool isSet ( LString const & ) const;

  void set ( LString const &, LString const &); //!< Sets a key in the objec

  bool isOfType ( LString const & ) const ;
  LString getType ( ) const;
  void setType ( LString const & ); //!< Set the type of the object
  void clear (); //!< Clears the object

  LHash<LString,LString> & getHash(); //!< Return the data hash of the object

};

#endif
