/* ****************************************************************************
   |      File: lconfparser.h
   |      Contains: base class LConfigParser, class LDefaultConfigParser
   |      Created: 18.03.1998
   |      Last Changed: 18.03.1998
   |      Version: 0.0
   |         
   |      ToDo: + just started
   |
   ************************************************************************* */

/* ====>> See also the ChangeLog in lconfparser.cc <<==== */

#ifndef _L_CONFPARSER_H_
#define _L_CONFPARSER_H_

#include <lcl.h>
#include <lcl/lvcs.h>
#include <lcl/lobject.h>
#include <lcl/lstring.h>
#include <lcl/liostream.h>
#include <lcl/lstreamproxy.h>
#include <lcl/lfile.h>
#include <lcl/lfstream.h>

#include <stdio.h>

class LConfigSystem;
class LConfigObject;

class LCL_EXPORT LConfigParser : public LObject {
  LVCS_DECLARE;

 protected:  

 public:
  virtual ~LConfigParser() {};

  virtual void parseHeader( LConfigSystem * ) = 0;
  virtual void parseMain( LConfigSystem * ) = 0;

  void parserError ( LString, LString );
  void parserError ( LString, LString, int line );
};

class LCL_EXPORT LDefaultConfigParser : public LConfigParser {
  LVCS_DECLARE;

 private:
  void readToEOL();
  int fileline;

 protected:
  LFile myInFile;
  LFIStream myInStream;
  LIStream & instream;

  LString commentChars;
  LString quoteChars;
  char open_br, close_br, delim_1, delim_2, escape, system_ch;


 public:
  LDefaultConfigParser ( LString const & fileName, LString const & comments = "#%", LString const & quoteChars = "" );
  LDefaultConfigParser ( LIStream &, LString const & comments = "#%", LString const & quoteChars = "" );

  virtual ~LDefaultConfigParser ();

  void internalCommand ( LConfigSystem * sys, LString cmd );

  virtual void parseHeader( LConfigSystem * );
  virtual void parseMain( LConfigSystem * );
  virtual void parseObject ( LConfigObject & );
};

class LCL_EXPORT LCGIConfigParser : public LConfigParser {
  LVCS_DECLARE;

 protected:
  LString query;

 public:

  LCGIConfigParser ();
  LCGIConfigParser ( LString request );

  virtual void parseHeader ( LConfigSystem * );
  virtual void parseMain ( LConfigSystem * );
  void parseObject ( LConfigObject &, LString );
};

#include <lcl/lconfsys.h>
#include <lcl/lconfobj.h>

#endif

