/* -*-mode: c++; coding: iso-8859-2-unix; -*- */

#ifndef _LEMIT_X_0_H_
#define _LEMIT_X_0_H_

class LCL_EXPORT LBasicSlot0 : public LBasicSlot {
 protected:
 public:

  virtual ~LBasicSlot0 () {};

  virtual void fire ( void ) = 0;
};

class LCL_EXPORT LCSlot0 : public LBasicSlot0 {
 public:
  void (*callback) ( void );
 public:
  LCSlot0 ( void (*_callback)(void) );
  virtual void fire ( void );

  virtual ~LCSlot0 () {};
};

inline LCSlot0::LCSlot0 ( void (*_callback)(void) ) :
  callback ( _callback )
{
}

inline void LCSlot0::fire ( void )
{
  LAutoLock _lock ( runningMutex );
      
  if ( callback && isActive() )
    {
      // Now lock the slot ...
      // ... for disconnect reasons      
      callback ();
    }
}

template < class Object >
class LCL_EXPORT LMethodSlot0 : public LBasicSlot0 {
 public:
  Object & object;
  void (Object::*callback) ( void );

 public:

  virtual ~LMethodSlot0 () {};

  LMethodSlot0 ( Object & );
  virtual void fire ( void );
};

template < class Object >
LMethodSlot0<Object>::LMethodSlot0 ( Object & obj ) :
  object ( obj ),
  callback ( NULL )
{
}

template < class Object >
inline void LMethodSlot0<Object>::fire ( void )
{
  LAutoLock _lock ( runningMutex );

  if ( (callback) && isActive() )
    (object.*callback) ();

}

class LCL_EXPORT LEmitter0 : public LBasicEmitter {
 protected:
 public:
  void emit ( void );
};

inline void LEmitter0::emit ( void )
{

  LSet < LManagedPointer<LBasicSlot> > myList = callbackList;

  LManagedPointer<LCursor> cursor = myList.createCursor ();

  for ( cursor->setToFirst(); cursor->isValid(); cursor->setToNext() )
    {
      LManagedPointer<LBasicSlot> slot = myList.elementAt ( cursor );

      LBasicSlot0 * slot0 = (LBasicSlot0*)slot.getPtr();

      if ( slot->isActive () )
	{
	  slot0 -> fire ();
	}
      else
	{
	  callbackList.removeElement ( slot );
	}
      
    }

  
}

#ifdef _LCL_COMPILER_MSVC_

template <class Object>
inline LSlotConnection connect_emitter_0 ( void (Object::*func)(void), Object & object, LEmitter0 & emitter )
{
  LMethodSlot0<Object> * slot = new LMethodSlot0<Object> ( object );
  slot->callback = func;
  return emitter.addSlot ( slot );
}

inline LSlotConnection connect_emitter_0 ( void (*func)(void), LEmitter0 & emitter )
{
  LCSlot0 * slot = new LCSlot0 ( func );
  return emitter.addSlot ( slot );
}

#else

#define connect_emitter_0 connect_emitter

template <class Object>
inline LSlotConnection connect_emitter ( void (Object::*func)(void), Object & object, LEmitter0 & emitter )
{
  LMethodSlot0<Object> * slot = new LMethodSlot0<Object> ( object );
  slot->callback = func;
  return emitter.addSlot ( slot );
}

inline LSlotConnection connect_emitter ( void (*func)(void), LEmitter0 & emitter )
{
  LCSlot0 * slot = new LCSlot0 ( func );
  return emitter.addSlot ( slot );
}

#endif


#endif
