/* -*-mode: c++; coding: iso-8859-2-unix; -*- */

#ifndef _LEMIT_X_2_H_
#define _LEMIT_X_2_H_

template < class Parameter1, class Parameter2 >
class LCL_EXPORT LBasicSlot2 : public LBasicSlot {
 protected:
 public:

  virtual ~LBasicSlot2 () {};

  virtual void fire ( Parameter1, Parameter2 ) = 0;
};

template < class Parameter1, class Parameter2 >
class LCL_EXPORT LCSlot2 : public LBasicSlot2<Parameter1,Parameter2> {
 public:
  void (*callback) ( Parameter1, Parameter2 );
 public:
  LCSlot2 ( void (*_callback)( Parameter1, Parameter2 ) );
  virtual void fire ( Parameter1, Parameter2 );

  virtual ~LCSlot2 () {};
};

template < class Parameter1, class Parameter2 >
inline LCSlot2<Parameter1, Parameter2>::LCSlot2 ( void (*_callback)( Parameter1, Parameter2 ) ) :
  callback ( _callback )
{
}

template < class Parameter1, class Parameter2 >
inline void LCSlot2<Parameter1, Parameter2>::fire ( Parameter1 p1, Parameter2 p2 )
{
  LAutoLock _lock ( runningMutex );

  if ( callback && isActive() )
    callback ( p1, p2 );
}

template < class Object, class Parameter1, class Parameter2 >
class LCL_EXPORT LMethodSlot2 : public LBasicSlot2<Parameter1, Parameter2> {
 public:
  Object & object;
  void (Object::*callback) ( Parameter1, Parameter2 );

 public:

  virtual ~LMethodSlot2 () {};

  LMethodSlot2 ( Object & );
  virtual void fire ( Parameter1, Parameter2 );
};

template < class Object, class Parameter1, class Parameter2 >
LMethodSlot2<Object, Parameter1, Parameter2>::LMethodSlot2 ( Object & obj ) :
  object ( obj ),
  callback ( NULL )
{
}

template < class Object, class Parameter1, class Parameter2 >
inline void LMethodSlot2<Object,Parameter1, Parameter2>::fire ( Parameter1 p1, Parameter2 p2 )
{
  LAutoLock _lock ( runningMutex );

  if ( (callback) && isActive() )
    (object.*callback) ( p1, p2 );
}

template < class Parameter1, class Parameter2 >
class LCL_EXPORT LEmitter2 : public LBasicEmitter {
 protected:
 public:
  void emit ( Parameter1, Parameter2 );
};

template < class Parameter1, class Parameter2 >
inline void LEmitter2<Parameter1, Parameter2>::emit ( Parameter1 p1, Parameter2 p2 )
{

  LSet < LManagedPointer<LBasicSlot> > myList = callbackList;

  LManagedPointer<LCursor> cursor = myList.createCursor ();

  for ( cursor->setToFirst(); cursor->isValid(); cursor->setToNext() )
    {
      LManagedPointer<LBasicSlot> slot = myList.elementAt ( cursor );

      LBasicSlot2<Parameter1, Parameter2> * slot2 = (LBasicSlot2<Parameter1, Parameter2>*)slot.getPtr();

      if ( slot->isActive () )
	{
	  slot2 -> fire ( p1, p2 );
	}
      else
	{
	  callbackList.removeElement ( slot );
	}
      
    }

  
}

#ifdef _LCL_COMPILER_MSVC_

template <class Object, class Parameter1, class Parameter2 >
inline LSlotConnection connect_emitter_2 ( void (Object::*func)(Parameter1, Parameter2), Object & object, LEmitter2<Parameter1, Parameter2> & emitter )
{
  LMethodSlot2<Object,Parameter1, Parameter2> * slot = new LMethodSlot2<Object,Parameter1, Parameter2> ( object );
  slot->callback = func;
  return emitter.addSlot ( slot );
}

template <class Parameter1, class Parameter2 >
inline LSlotConnection connect_emitter_2 ( void (*func)(Parameter1, Parameter2), LEmitter2<Parameter1, Parameter2> & emitter )
{
  LCSlot2<Parameter1, Parameter2> * slot = new LCSlot2<Parameter1, Parameter2> ( func );
  return emitter.addSlot ( slot );
}

#else

#define connect_emitter_2 connect_emitter


template <class Object, class Parameter1, class Parameter2 >
inline LSlotConnection connect_emitter ( void (Object::*func)(Parameter1, Parameter2), Object & object, LEmitter2<Parameter1, Parameter2> & emitter )
{
  LMethodSlot2<Object,Parameter1, Parameter2> * slot = new LMethodSlot2<Object,Parameter1, Parameter2> ( object );
  slot->callback = func;
  return emitter.addSlot ( slot );
}

template <class Parameter1, class Parameter2 >
inline LSlotConnection connect_emitter ( void (*func)(Parameter1, Parameter2), LEmitter2<Parameter1, Parameter2> & emitter )
{
  LCSlot2<Parameter1, Parameter2> * slot = new LCSlot2<Parameter1, Parameter2> ( func );
  return emitter.addSlot ( slot );
}
#endif


#endif
