/* -*-mode: c++; coding: iso-8859-2-unix; -*- */

/* LCL - The Linux Class Library
 * Copyright (C) 1998-2003 Jens Reimann
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef _LCL_ERROR_CODE_H_
#define _LCL_ERROR_CODE_H_

#include <lcl.h>

class LCL_EXPORT LErrorCode;

//#include <lcl/lstring.h>

class LCL_EXPORT LErrorCode {
protected:
  //  LString * m_module, * m_submodule;
  char m_module [ 16 ];
  char m_submodule [ 16 ];
  char m_asstring [ 128 ];
  luint32 m_code;
public:
  LErrorCode ();
  LErrorCode ( LErrorCode const & p1 );
  //  LErrorCode ( LString const & module, LString const & submodule, luint32 code );
  LErrorCode ( char const * module, char const * submodule, luint32 code );
  virtual ~LErrorCode ();

  LErrorCode const & operator = ( LErrorCode const & p1 );

  void setModule ( char const * module );
  void setSubModule ( char const * submodule );
  void setCode ( luint32 code );

  char const * getModule ( ) const;
  char const * getSubModule ( ) const;
  luint32 getCode () const;
  
  char const * asString () const;
};

#define LCL_ERROR_CODE(s,c) LErrorCode("LCL",s,c)
#define LCL_SYS_ERROR_CODE(c) LCL_ERROR_CODE("SYS",c)

#define LCL_SYS_CODE_OUT_OF_MEMORY     0x00000001L
#define LCL_SYS_CODE_NULL_POINTER      0x00000002L
#define LCL_SYS_CODE_ASSERTION_FAILED  0x00000003L

#endif
