/* ****************************************************************************
   |      File: lfdlist.h
   |      Contains: class definition for LFDList
   |      Created: 10.11.1998
   |      Last Changed: 10.11.1998
   |      Version: 0.0
   |         
   |      ToDo: + just started
   |
   ************************************************************************* */

/* ====>> See also the ChangeLog in lfdlist.cc <<==== */

#ifndef _L_FDLIST_H_
#define _L_FDLIST_H_

#include <sys/types.h>
#include <lcl/lset.h>

class LFDList {
 protected:
  LSet<int> m_fds;

 public:
  LFDList ();
  LFDList ( LFDList const & );
  LFDList ( fd_set const & );
  LFDList ( fd_set const * );

  virtual ~LFDList () {};

  void set ( int fd );
  void unset ( int fd );
  bool isSet ( int fd ) const;
  void clear ();

  void copyFrom ( LFDList const & );
  void copyFrom ( fd_set const * );
  void addAllFrom ( LFDList const & );
  void addAllFrom ( fd_set const * );

  int highest () const;

  LFDList & operator = ( LFDList const & );
  LFDList operator + ( LFDList const & ) const;
  void operator += ( LFDList const & );

  operator fd_set ();

  LSet<int> const & getList () const;

  void dump () const;

};

#endif
