#ifndef LHTTPD_H
#define LHTTPD_H

#include <lcl/lsocket.h>
#include <lcl/lset.h>
#include <lcl/lvcs.h>
#include <lcl/lemit.h>

#include <lcl/lhttp.h>
#include <lcl/lhash.h>
#include <lcl/lthread.h>


class LHTTPConnection;
class LHTTPDaemon;

class LCL_EXPORT LHTTPConnection {
  friend class LHTTPDaemon;

 protected:
  LSocket4Inet socket;
  time_t lastData;
  bool isLost, isComplete;
  bool cr;

  static long timeoutValue;

  LString string_buffer;

 public:
  LHTTPConnection ( LSocket4Inet const & );
  
  bool complete () const;
  bool timeout () const;
  bool lost () const;

  void readEvent ( LFileDesc * );

  LString getBuffer () const;
  LSocket4Inet & getSocket ();
};

/*!
 * \class LHTTPDaemon
 * \brief LHTTP
 */

class LCL_EXPORT LHTTPDaemon {
  LVCS_DECLARE;

 protected:
  LSet<LHTTPConnection*> connectionList;
  LMethodThreadFn <LHTTPDaemon> checkerFn;  

  void processComplete ( LHTTPConnection * );

 public:

  void checker ();

  LEmitter2 < LHTTPRequest, LSocket4Inet * > request;

  LHTTPDaemon ( );
  ~LHTTPDaemon ();

  void connection ( LSocket4Inet & );

};

#endif
