#ifndef _LINTEPRETER_COMMANDS_H_
#define _LINTEPRETER_COMMANDS_H_

#include <lcl.h>

#include <lcl/linterpreter.h>

#include <lcl/lstreamproxy.h>

namespace LCommands {

  namespace Base {
    _BASE_COMMAND_DEFINE(func)
    _BASE_COMMAND_DEFINE(unfunc)

    _BASE_COMMAND_DEFINE(equal)
    _BASE_COMMAND_DEFINE(not)

    _BASE_COMMAND_DEFINE(add)
    _BASE_COMMAND_DEFINE(sub)
    _BASE_COMMAND_DEFINE(mul)
    _BASE_COMMAND_DEFINE(div)
    _BASE_COMMAND_DEFINE_RES(and)
    _BASE_COMMAND_DEFINE_RES(or)
    _BASE_COMMAND_DEFINE_RES(xor)
    _BASE_COMMAND_DEFINE(inv)
      _BASE_COMMAND_DEFINE(inc)
      _BASE_COMMAND_DEFINE(dec)

    _BASE_COMMAND_DEFINE_RES(sleep)

    _BASE_COMMAND_DEFINE_RES(int)
    _BASE_COMMAND_DEFINE_RES(long)
    _BASE_COMMAND_DEFINE_RES(short)
    _BASE_COMMAND_DEFINE_RES(double)
    _BASE_COMMAND_DEFINE_RES(float)
    _BASE_COMMAND_DEFINE_RES(char)
    _BASE_COMMAND_DEFINE_RES(unsigned_int)
    _BASE_COMMAND_DEFINE_RES(unsigned_long)
    _BASE_COMMAND_DEFINE_RES(unsigned_short)
    _BASE_COMMAND_DEFINE_RES(unsigned_char)

    _BASE_COMMAND_DEFINE(round)

    _BASE_COMMAND_DEFINE(echo)
    _BASE_COMMAND_DEFINE(flush)
    _BASE_COMMAND_DEFINE(set)
    _BASE_COMMAND_DEFINE(get)
    _BASE_COMMAND_DEFINE(is_set)
    _BASE_COMMAND_DEFINE(get_arg)
    _BASE_COMMAND_DEFINE(set_arg)
    _BASE_COMMAND_DEFINE(arg_num)

    LCL_EXPORT void registerAll ( LInterpreter & inter );
  }

  namespace String {

    class LCL_EXPORT cmd_strcat : public LInterpreter::Command {
    protected:  
    public:
      cmd_strcat ();
      LVariant exec ( LInterpreter::Context & context, LTable<LVariant> const & args );
    };

    _BASE_COMMAND_DEFINE(strlist);
    _BASE_COMMAND_DEFINE(trim);

    _BASE_COMMAND_DEFINE(lcl_log);
    _BASE_COMMAND_DEFINE(lcl_trace);

    LCL_EXPORT void registerAll ( LInterpreter & inter );    

  }

  namespace Time {

    /*!
     * \class ctime
     */
    _BASE_COMMAND_DEFINE(ctime)

    /*!
     * \class time
     */
    _BASE_COMMAND_DEFINE(time)

    LCL_EXPORT void registerAll ( LInterpreter & inter );

  }

}

#endif
