#ifndef _LIOSTREAM_H_
#define _LIOSTREAM_H_

#include <lcl.h>
#include <lcl/lvcs.h>

class LCL_EXPORT LIStream;
class LCL_EXPORT LOStream;
class LCL_EXPORT LIOStream;

#include <lcl/lstring.h>
#include <lcl/lxcpt.h>

LCL_EXPORT LOStream & endl ( LOStream & );
LCL_EXPORT LOStream & flush ( LOStream & );

/*
class LStreamException : public LBasicException {
  LVCS_DECLARE;
};
*/

class LCL_EXPORT LErrorStreamException {
  LVCS_DECLARE;
 public:
  int err;

  LErrorStreamException ( int err );
};

class LCL_EXPORT LStreamOException : public LErrorStreamException {
  LVCS_DECLARE;
 public:
  LOStream & stream;
  
  LStreamOException ( int err, LOStream & );
  
};

class LCL_EXPORT LEndOfStreamException {
  LVCS_DECLARE;
 public:
  LIStream & stream;
  unsigned long nData;

  LEndOfStreamException ( LIStream &, unsigned long cnt = 0);
};

class LCL_EXPORT LIStream {
  LVCS_DECLARE;
  friend class LEndOfStreamException;
 protected:
  bool EOS;

 public:

  LIStream ();
  virtual ~LIStream ();

  //  virtual bool mayRead () = 0;
  virtual int read ( char & c ) = 0;
  virtual int read ( void * _ptr, unsigned long len );

  LIStream & operator >> ( char & );  
  LString gets ( LString const & delims = LString("\n"), LString const & ignore = LString("\r") );

  virtual bool eos () const;
};

class LCL_EXPORT LOStream {
  LVCS_DECLARE;
 public:

  //  virtual bool mayWrite () = 0;
  virtual int write ( char c ) = 0;
  virtual int write ( void const *, unsigned long len );

  LOStream & operator << ( char const * );
  LOStream & operator << ( char );

  LOStream & operator << ( int i );
  LOStream & operator << ( unsigned int i );

  LOStream & operator << ( long l );
  LOStream & operator << ( unsigned long ul );

  LOStream & operator << ( short i );
  LOStream & operator << ( unsigned short i );

  LOStream & operator << ( double d );

  LOStream & operator << ( LOStream & (*)(LOStream&) );

  virtual void flush ();

  virtual ~LOStream ();
};

class LCL_EXPORT LIOStream : virtual public LIStream, virtual public LOStream {
  LVCS_DECLARE;
  virtual ~LIOStream ();
};

#endif

