#ifndef _LCL_MEMORY_H_
#define _LCL_MEMORY_H_

#include <lcl.h>
#include <lcl/liostream.h>

LCL_EXPORT void * lmem_malloc ( luint32 size, char const * name );
LCL_EXPORT void * lmem_realloc ( void * ptr, luint32 size, char const * name );

LCL_EXPORT void lmem_free ( void * ptr );

LCL_EXPORT char * lmem_strdup ( char const * str, char const * name );

LCL_EXPORT void lmem_dump_stats ( LOStream & out );

LCL_EXPORT extern bool lmem_debug;

#define lcl_malloc(size,name) (lmem_debug) ? (lmem_malloc((size),(name))) : (malloc((size)))
#define lcl_free(ptr) (lmem_debug) ? (lmem_free((ptr))) : (free((ptr)))
#define lcl_realloc(ptr,size,name) (lmem_debug) ? (lmem_realloc((ptr),(size),(name))) : (realloc((ptr),(size)))
#define lcl_strdup(str) (lmem_debug) ? (lmem_strdup((str),(name))) : (strdup((str)))

#endif
