#ifndef _LPARSER_H_
#define _LPARSER_H_

#include <lcl.h>
#include <lcl/lstringtokenizer.h>
#include <lcl/linterpreter.h>
#include <lcl/lvcs.h>

class LCL_EXPORT LParser : public LObject {
  LVCS_DECLARE;
 protected:
 public:
  virtual LManagedPointer<LInterpreter::Sequence> parse ( LString const & ) = 0;

  class Exception : public LBasicException {
  protected:
    LString reason;
  public:
    Exception ( LString const & _reason );
    virtual void log ( ) const;
  };
};

class LCL_EXPORT LParser_LSLL : public LParser {
  LVCS_DECLARE;
 protected:
  LVariant createConst ( LString const & str );
  LString prepareWS ( LString const & str );
  LManagedPointer<LInterpreter::Sequence> step_parse ( LStringTokenizer & tok, unsigned long & pos );
 public:
  virtual LManagedPointer<LInterpreter::Sequence> parse ( LString const & );
};

#endif
