#ifndef _LREFERENCE_H_
#define _LREFERENCE_H_

#include <lcl/lpointer.h>
#include <stdlib.h>
#include <lcl/lxcpt.h>


template <class Type>
class LReference {
 protected:
  Type * item;
  unsigned long * references;

  void attach ( LReference const & p1 )
    {
      references = p1.references;
      (*references)++;
      item  = p1.item;
    }

  void attach ( Type * ptr )
    {
      if ( references )
	detach ();

      references = new unsigned long;
      *references = 1;
      item = ptr;
    }

  void detach ()
    {
      references--;
      if ( !references ) {
	delete references;
	delete item;
	references = NULL;
	item = NULL;
      }
    }

 public:
  LReference () :
    item ( NULL ),
    references ( NULL )
    {
      attach ( new Type );
    }

  LReference ( Type & data ) :
    item ( NULL ),
    references ( NULL )
    {
      attach ( &data );
    }

  LReference ( Type * data ) :
    item ( NULL ),
    references ( NULL )
    {
      attach ( data );
    }

  LReference ( LReference<Type> const & p1 ) :
    item ( NULL ),
    references ( NULL )
    {
      attach ( p1 );
    }

  ~LReference ()
    {
      detach ();
    }

  operator Type & ()
    {
      return *item;
    }

  operator Type * ()
    {
      return item;
    }

  Type * operator -> ()
    {
      return item;
    }

  bool operator == ( LReference<Type> const & p1 ) const
  {
    return p1.item == item;
  }
};

#endif
