#ifndef _LSELECTLOOP_H_
#define _LSELECTLOOP_H_

class LSelectLoop;

#include <lcl.h>
#include <lcl/lvcs.h>
#include <lcl/lstring.h>
#include <lcl/lhash.h>
#include <lcl/lset.h>
#include <lcl/lfiledesc.h>
#include <lcl/lemit.h>

class LCL_EXPORT LSelectLoop {

  LVCS_DECLARE;

  friend class UnregDescIter;
  friend class LFileDesc;

 private:
  #ifndef _LCL_SYS_WIN32_PURE_
  fd_set r_fds, w_fds, x_fds;
  long max_fd;
  #else
  LSet<LFileDescriptor> read_list, write_list, except_list;
  LSet<LFileDescriptor> read_res, write_res, except_res;  
  #endif

 private:
  LSet<LFileDesc*> fdList;
  LHash<LFileDescriptor, unsigned long> fdMasks;
  void generatePollList ( );
  long doThePoll ();
  void emitFDEvents ();
  bool running;

  unsigned long timeoutValue;

 protected:

  static LHash < LThreadID, LSelectLoop* > loopThreadHash;
  static void unregisterForAll ( LFileDesc * );

  LSelectLoop ();

  void reg ( LFileDesc * );
  void unreg ( LFileDesc * );
  
 public:
  
  LEmitter0 timeoutEvent;

  static LSelectLoop * getInstance ();

  void setTimeout ( unsigned long );

  void loop ();
};

#endif
