#ifndef _LSEMAPHORE_H_
#define _LSEMAPHORE_H_

#ifdef _WIN32
#else
   #include <semaphore.h>
#endif

#include <lcl.h>

class LSemaphoreArray;

class LCL_EXPORT LSemaphore {
 protected:
  friend class LSemaphoreArray;
#ifdef _WIN32
  HANDLE sem;
#else
  sem_t sem;
#endif

 public:
  LSemaphore ( unsigned long count = 0 );
  ~LSemaphore ();

  void post ( long = 1 );
  #ifdef _WIN32
  bool wait ( int sec = INFINITE );
  #else
  bool wait ( int sec = 0 );
  #endif
  bool trywait ();
};

class LCL_EXPORT LSemaphoreArray {
protected:

  LSemaphore ** sems;
  long size;

public:

  LSemaphoreArray ( long size );
  ~LSemaphoreArray ( );

  void waitAll ();
  long waitForNext (void);

  void set ( long pos, LSemaphore * );
  LSemaphore * get ( long pos );
};



#endif
