#ifndef _LSERIALIZE_H_
#define _LSERIALIZE_H_

class LSerializer;

#include <lcl/lstring.h>

#include <lcl.h>

class LCL_EXPORT LISerializer {
 protected:
  LIStream & instream;

 public:
  LISerializer ( LIStream & );

  virtual void thaw ( LString const & type ) = 0;
};

class LCL_EXPORT LOSerializer {
 protected:
  LOStream & outstream;

 public:
  LOSerializer ( LOStream & );

  virtual void freeze ( LString const & type, LString const & value ) = 0;
};

class LCL_EXPORT LIOSerializer : public LISerializer, LOSerializer {
 protected:  
 public:
  LIOSerializer ( LIOStream & );
};

class LCL_EXPORT LSerializer {
 protected:
  LString buffer;

 public:

  LSerializer ( LString const & = LString() );
  virtual ~LSerializer ();

  LString getBuffer () const;
  void setBuffer ( LString const & _buffer );

  virtual void freeze ( LString const & type, LString const & value ) = 0;
  virtual LString thaw ( LString const & type ) = 0;
};


LCL_EXPORT LSerializer & operator << ( LSerializer & ser, int );
LCL_EXPORT LSerializer & operator >> ( LSerializer & ser, int & );

LCL_EXPORT LSerializer & operator << ( LSerializer & ser, long );
LCL_EXPORT LSerializer & operator >> ( LSerializer & ser, long & );

LCL_EXPORT LSerializer & operator << ( LSerializer & ser, unsigned long );
LCL_EXPORT LSerializer & operator >> ( LSerializer & ser, unsigned long & );

LCL_EXPORT LSerializer & operator << ( LSerializer & ser, char );
LCL_EXPORT LSerializer & operator >> ( LSerializer & ser, char & );

LCL_EXPORT LSerializer & operator << ( LSerializer & ser, unsigned long );
LCL_EXPORT LSerializer & operator >> ( LSerializer & ser, unsigned long & );

LCL_EXPORT LSerializer & operator << ( LSerializer & ser, double );
LCL_EXPORT LSerializer & operator >> ( LSerializer & ser, double & );

LCL_EXPORT LSerializer & operator << ( LSerializer & ser, LSerializer const & );
LCL_EXPORT LSerializer & operator >> ( LSerializer & ser, LSerializer & );


class LCL_EXPORT LDefaultSerializer : public LSerializer {
 protected:
  bool getNext ( LString & type, LString & value );
  void setNext ( LString const & type, LString const & value );

  LString encode ( LString const & );
  LString decode ( LString const & );

 public:
  LDefaultSerializer ( LString const & = LString() );
  virtual ~LDefaultSerializer ();

  virtual void freeze ( LString const & type, LString const & value );
  virtual LString thaw ( LString const & type );

};

#endif
