#ifndef _LSYSINFO_H_
#define _LSYSINFO_H_

#include <lxcpt.h>
#include <lstring.h>

class LSystemInfoException : public LBasicException {
 public:
  enum  ErrorCode { NOT_SUPPORTED, NOT_AVAILABLE, UNKOWN };

 protected:
  ErrorCode ec;
 public:

  LSystemInfoException ( ErrorCode _ec, const char * _filename = __FILE__, unsigned long _line = __LINE__ );
  virtual void log ( ) const;

  ErrorCode getErrorCode () const;
};

class LSystemInfo {
 protected:
  static LSystemInfo * theInstance;
  LSystemInfo ();

 public:
  static LSystemInfo * getInstance ();

  LString getHostName () const;

  // uname
  LString getMachine () const;
  LString getOSRelease () const;
  LString getOSVersion () const;
  LString getOS() const;
  LString getProcessor () const;
};

#endif
