/* -*-mode: c++; coding: iso-8859-2-unix; -*- */

/* LCL - The Linux Class Library
 * Copyright (C) 1998-2003 Jens Reimann
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef _LCL_TICKER_H_
#define _LCL_TICKER_H_

#include <lcl.h>

#include <lcl/lstring.h>
#include <lcl/lthread.h>
#include <lcl/lemit.h>

class LCL_EXPORT LTicker {
 protected:
  LString m_name;

 public:
  LTicker ( LString const & name = LString() );
  virtual ~LTicker ();

  LEmitter1 < LString > tickerNamed;
  LEmitter0 ticker;

  virtual void tick ( void );
};

class LCL_EXPORT LAsyncTicker : public LTicker {
 protected:
  LMethodThreadFn<LAsyncTicker> runnerFn;

  bool running;
  bool exited;
  unsigned long m_timeout;

 public:
  LAsyncTicker ( unsigned long timeout, LString const & name = LString() );
  virtual ~LAsyncTicker ();

  void runner ( void );

  virtual void tick ( void );
};

#endif
