/* -*-mode: c++; coding: iso-8859-2-unix; -*- */
/* ****************************************************************************
   |      File: ltime.h
   |      Contains: class definition for LTime
   |      Created: 29.07.1998
   |      Last Changed: 29.07.1998
   |      Version: 0.0
   |         
   |      ToDo: + just started
   |
   ************************************************************************* */

/* ====>> See also the ChangeLog in ltime.cc <<==== */

#ifndef _L_TIME_H_
#define _L_TIME_H_

#include <lcl.h>
#include <lcl/lobject.h>

class LCL_EXPORT LTime {
 protected:
  luint32 m_time;

 public:
  LTime ();
  LTime ( LTime const & );
  LTime ( luint32 _time );
  LTime ( luint8 hours, luint8 mins, luint8 secs, luint16 msecs = 0 );

  lint32 compare ( LTime const & p1 ) const;
  bool equal ( LTime const & p1 ) const;

  bool operator ==( const LTime & p1 ) const;
  bool operator !=( const LTime & p1 ) const;
  bool operator < ( const LTime & p1 ) const;
  bool operator > ( const LTime & p1 ) const;

  LTime operator + ( const LTime & p1 ) const;
  LTime operator - ( const LTime & p1 ) const;

  LTime & operator = ( const LTime & p1 );

  void set ( LTime const & );
  void set ( luint8 hours, luint8 mins, luint8 secs, luint16 msecs );

  luint32 getMSecs () const;
  luint8 getSecs () const;
  luint8 getMins () const;
  luint8 getHours () const;

  luint32 asMSecs () const;
  luint32 asSecs () const;
  luint32 asMins () const;
  luint32 asHours () const;

  void setMSecs ( luint32 );
  void setSecs ( luint8 );
  void setMins ( luint8 );
  void setHours ( luint8 );

  void setAsMSecs ( luint32 );
  void setAsSecs ( luint32 );
  void setAsMins ( luint32 );
  void setAsHours ( luint32 );

  LTime diff ( const LTime & p1 ) const;
  void later ( const LTime & p1 );
  void earlier ( const LTime & p1 );

  static LTime now();
};

#include <iostream.h>
#include <lcl/liostream.h>

ostream & operator << ( ostream &out, const LTime );
LOStream & operator << ( LOStream & out, LTime const & );

#endif
