
#ifndef _LCL_TRACE_FILE_H_
#define _LCL_TRACE_FILE_H_


#include <lcl.h>
#include <lcl/lhash.h>
#include <lcl/lmutex.h>
#include <lcl/lstack.h>
#include <lcl/lheap.h>
#include <lcl/lutils.h>
#include <lcl/ltrace.h>
#include <lcl/lfile.h>
#include <lcl/lfstream.h>

class LCL_EXPORT LTraceOutput_File : public LTraceOutput {
protected:
  static LGuardMutex syncMutex;
 protected:
  LFile * fileOutputFD;
  LOStream * fileOutput;
  luint32 m_maxSize;
  luint32 m_maxFiles;
  luint32 m_size;
  luint32 m_fileNr;
  LString m_template;
  LString m_location;
  LString m_fileName;
  bool m_use_tpl;

  LString getFileName () const;

  void closeOutput ( void );

  void setFile ( LString const & fname );

  void setOutput ( LString const & location );
  void setTemplate ( LString const & tpl );

 public:
  LTraceOutput_File ();
  virtual ~LTraceOutput_File ();
  virtual void trace ( LTraceMessage const & );
  virtual void setOptions ( LHash<LString,LString> const & vars );
};

#endif
