
#ifndef _LCL_TRACE_OUTPUT_H_
#define _LCL_TRACE_OUTPUT_H_


#include <lcl.h>
#include <lcl/lhash.h>
#include <lcl/lmutex.h>
#include <lcl/lstack.h>
#include <lcl/lheap.h>
#include <lcl/lutils.h>
#include <lcl/ltrace.h>
#include <lcl/lfile.h>
#include <lcl/lfstream.h>

class LCL_EXPORT LTraceOutput_OStream : public LTraceOutput {
protected:
  static LGuardMutex syncMutex;
 protected:
  LOStream & outputStream;
  bool compatibleOutput;
  bool syncOutput;
  
  LOStream * localOutput;
  LFileDesc * localOutputFD;

  LGuardMutex outputControlLock;

  void closeOutput ( void );
  void setOutput ( LString const & location );

 public:
  LTraceOutput_OStream ();
  virtual ~LTraceOutput_OStream ();
  virtual void trace ( LTraceMessage const & );
  virtual void setOptions ( LHash<LString,LString> const & vars );
};

#endif
