/* ****************************************************************************
   |      File: lip.h
   |      Contains: base class definition for LExcept
   |      Created: 07.06.1998
   |      Last Changed: 07.06.1998
   |      Version: 0.0
   |         
   |      ToDo: + just started
   |
   ************************************************************************* */

/* ====>> See also the ChangeLog in lxcpt <<==== */

#ifndef _L_XCPT_H_
#define _L_XCPT_H_

#include <lcl.h>

class LCL_EXPORT LBasicException;


#define lcl_assert(exp) if ( !(exp) ) throw LAssertionException ( __FILE__, __LINE__, #exp );
#ifdef assert
#undef assert
#define assert(exp) lcl_assert(exp)
#endif


#include <lcl/lerrcode.h>

//#include <lcl/lhash.h>

/*
class LCL_EXPORT LInfoException {
 protected:
  LHash<LString, LString> info;
 public:
  LInfoException & set ( LString const &, LString const & );
  virtual void log ( ) const;
};
*/

class LCL_EXPORT LFileInfoException {
protected:
  char * filename;
  lint32 line;
public:
  LFileInfoException ( char const * _filename, lint32 _line );
  LFileInfoException ( LFileInfoException const & );
  virtual ~LFileInfoException ();
  virtual void log ( ) const;
};

class LCL_EXPORT LStackInfoException {
 protected:
  char ** stack_v;
 public:
  LStackInfoException ();
  LStackInfoException ( LStackInfoException const & p1 );
  virtual ~LStackInfoException ();

  virtual void log ( ) const;
};

class LCL_EXPORT LErrorCodeException {
 protected:
  LErrorCode m_code;
 public:
  LErrorCodeException ( );
  LErrorCodeException ( LErrorCode const & );
  LErrorCodeException ( LErrorCodeException const & p1 );
  virtual ~LErrorCodeException ();

  virtual void log ( ) const;
};

class LCL_EXPORT LBasicException : public /*LInfoException,*/ LFileInfoException, LStackInfoException, LErrorCodeException {
 protected:
  char * xreason;

 public:
  LBasicException ( const char * _filename = __FILE__, unsigned long _line = __LINE__, const char * _reason = "", LErrorCode const & = LErrorCode() );
  LBasicException ( LBasicException const & );
  virtual ~LBasicException ();

  virtual void log ( ) const;
};

class LCL_EXPORT LOutOfMemoryException : public LBasicException {
 protected:
 public:
  LOutOfMemoryException ( const char * _filename = __FILE__, unsigned long _line = __LINE__ );
  virtual void log ( ) const;
};

class LCL_EXPORT LNullPointerException : public LBasicException {
 protected:
 public:
  LNullPointerException ( const char * _filename = __FILE__, unsigned long _line = __LINE__ );
  virtual void log ( ) const;
};

class LCL_EXPORT LIOException : public LBasicException {
 protected:
 public:
  enum { read, write, extra } LIODirection;

  LIOException ( const char * _filename = __FILE__, unsigned long _line = __LINE__ );
  virtual void log ( ) const;
};


class LCL_EXPORT LWrongParameterException : public LBasicException {
 protected:
  char * reason;
 public:
  LWrongParameterException ( const char * _filename, unsigned long _line, char const * reason );
  virtual ~LWrongParameterException ();
  virtual void log ( ) const;
};

class LCL_EXPORT LAssertionException : public LBasicException {
 protected:
  char * assertion;
 public:
  LAssertionException ( char const * _filename, unsigned long _line, char const * _assertion );
  virtual ~LAssertionException ();
  virtual void log ( ) const;
};

#endif
