
# Oracle is disabled by default
%{!?oracle:%define oracle 0}

Summary: The LinuxClassLibrary
Name: lcl
Version: 0.7.5
Release: 2
License: LGPL
Group: System Environment/Libraries
URL: http://dentrassi.de/lcl
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Prefix: %{prefix}
Source: ftp://dentrassi.de/pub/lcl/lcl-%{version}.tar.gz

BuildRequires: pcre-devel >= 3.0

%define prefix /usr

%description
The LinuxClassLibrary

%package devel
Summary: The LCL Development Package
Group: Development/Libraries
%description devel
The LCL Development Package

%package doc
Summary: The LCL Developer Documentation Package
Group: Development/Libraries
%description doc
The LCL Developers Documentation

%package tools
Summary: The LCL Tool Package
Group: Application/Tools
%description tools
The LCL Tool Package

%if %{oracle}
%package oci8
Summary: The LCL OCI8 PlugIn Package
Group: Development/Libraries
%description oci8
The LCL OCI8 PlugIn Package
%endif

%prep
%setup

%build

if [ ! -f configure ]; then
  CFLAGS="$RPM_OPT_FLAGS" make -f admin/Makefile.cvs
else
  CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%prefix \
%if %{oracle}
			--with-oci8 \
%endif

fi

if [ "$SMP" != "" ]; then
  (make "MAKE=make -k -j $SMP"; exit 0)
  make
else
  make
fi

make docs

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{prefix}/include $RPM_BUILD_ROOT/%{prefix}/lib
make prefix=$RPM_BUILD_ROOT%{prefix} install

%post -p /sbin/ldconfig

%postrun -p /sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr ( 0755, root, root)
%{prefix}/lib/liblcl.so
%{prefix}/lib/liblcl.so.0
%{prefix}/lib/liblcl.so.0.0.0
%{prefix}/share/lcl/inter/liblclinter_win32.so
%{prefix}/share/lcl/inter/liblclinter_win32.a
%{prefix}/share/lcl/inter/liblclinter_win32.la
%{prefix}/share/lcl/inter/liblclinter_process.so
%{prefix}/share/lcl/inter/liblclinter_process.a
%{prefix}/share/lcl/inter/liblclinter_process.la

%if %{oracle}
%files oci8
%defattr ( 0755, root, root)
%{prefix}/share/lcl/dbsys/liblcldbsys_oci8.so
%{prefix}/share/lcl/dbsys/liblcldbsys_oci8.a
%{prefix}/share/lcl/dbsys/liblcldbsys_oci8.la
%endif

%files devel
%defattr (0644,root,root)
%{prefix}/lib/liblcl.a
%{prefix}/lib/liblcl.la
%{prefix}/include/lcl.h
%{prefix}/include/lcl_common.h
%{prefix}/include/lcl/*.h
%{prefix}/share/lcl/lcl.pc

%files doc
%defattr (0644,root,root)
%{prefix}/share/doc/lcl/html/*
%{prefix}/share/doc/lcl/rtf/*
%{prefix}/share/doc/lcl/latex/*

%files tools
%defattr (0755,root,root)
%{prefix}/bin/lcl_crypt
%{prefix}/bin/lcl_inter2
%{prefix}/bin/lcl_test_str
%{prefix}/bin/lcl_test_fb_mutex
%{prefix}/bin/lcl_ascii_server
%{prefix}/bin/lcl_test_conf
%{prefix}/bin/lcl_dbsys
