

all: dll lib

dll: lcl-win32-dll lcl-win32-dll-debug

lib: lcl-win32-lib lcl-win32-lib-debug

!include ../Makefile.def.MS

UNICODE_BASE=../unicode

CXXFLAGS_COMMON=$(CXXFLAGS_COMMON) /I../unicode /D_LCL_BUILD_LIB_=1
DEFINES_LIB=/DBUILD_STATIC=1
DEFINES_DLL=/DBUILD_LCL_DLL=1
DEFINES_LIB_DEBUG=/DBUILD_STATIC=1
DEFINES_DLL_DEBUG=/DBUILD_LCL_DLL=1

LDFLAGS_DLL=$(LDFLAGS_DLL)
LDFLAGS_LIB=$(LDFLAGS_LIB)
LDFLAGS_DLL_DEBUG=$(LDFLAGS_DLL_DEBUG)
LDFLAGS_LIB_DEBUG=$(LDFLAGS_LIB_DEBUG)

ifdef UNICODE
LDFLAGS_DLL=$(LDFLAGS_DLL) $(UNICODE_BASE)/lcl_unicode.lib
LDFLAGS_LIB=$(LDFLAGS_LIB) $(UNICODE_BASE)/lcl_unicode_static.lib
LDFLAGS_DLL_DEBUG=$(LDFLAGS_DLL_DEBUG) $(UNICODE_BASE)/lcl_unicode_debug.lib
LDFLAGS_LIB_DEBUG=$(LDFLAGS_LIB_DEBUG) $(UNICODE_BASE)/lcl_unicodestatic_debug.lib
endif

LIB_WIN32_OBJS=lapp.obj lfdlayer.win32.obj lvcs.obj liostream.obj lutils.obj lsimplelist.obj lthread.obj lcursor.obj lxcpt.obj lobject.obj lbuffer.obj larray.obj ldatetime.obj lbaseobject.obj lbasecollection.obj lstring.obj lconfsys.obj lconfobj.obj lconfparser.obj ltrace.obj lstringtokenizer.obj lstreamproxy.obj lmutex.obj lfstream.obj lfile.obj lloghandler.obj llogsystem.obj lfiledesc.obj lsockaddr.obj lsockaddr.4inet.obj lserialize.obj lregex.obj lcolor.obj limage.obj limage.bmp.obj limage.ppm.obj lrevision.obj lstrstream.obj lcrypt.obj lcrypt.xor.obj lconfparser_dir.obj lconfmodule.obj  ldirectory.obj lwin32.select.obj lfdlayer.common.obj lwin32.fd_basic.obj lwin32.fd_socket.obj lwin32.fd_file.obj lreg32.obj lselectloop.obj lhttp.obj lsocket.obj lsserver.obj lhttpd.obj lhttpdir.obj lplugin.obj llibrary.obj lhttpproc.plugin.obj lurl.obj lsem.obj lhttpproc_tree.obj lappcontrol.obj lemitx.obj lmemory.obj lappcontrol_class.obj liobuffer.obj lwin32service.obj lwin32servicemain.obj lparser.obj linterpreter.obj linterpreter_plugin.obj linterpreter_commands.obj lmath.obj lvariant.obj lticker.obj ltimer.obj lqueue.obj lappevent.obj ldbsystem.obj ldbsystem.plugin.obj lcollection.obj ltime.obj ltrace_output.obj ltracefunc.obj lcmdline.obj lstringbase.obj  lstringreplace.obj lpoint.obj lrect.obj lerrcode.obj ltrace_file.obj
ifdef UNICODE
LIB_WIN32_OBJS=$(LIB_WIN32_OBJS) lstringstorage.obj lstring32.obj
endif
LIB_WIN32_OBJS_IGNORE = lcond.obj lsocket.obj lcgi.obj

WIN_LIBS = kernel32.lib ws2_32.lib advapi32.lib user32.lib

PCRE_BASE=../pcre
PCRE_STATIC_LIB=$(PCRE_BASE)/pcre_win32_static.lib
PCRE_STATIC_DEBUG_LIB=$(PCRE_BASE)/pcre_win32_static_debug.lib

lcl-win32-lib: $(LIB_WIN32_OBJS:.obj=.s_obj)
	@-echo Assembling LCL as static LIB ...
	@lib $(LDFLAGS_COMMON) $(LDFLAGS_LIB) $(PCRE_STATIC_LIB) $(LIB_WIN32_OBJS:.obj=.s_obj) /out:lcl_win32_static.lib
	@-echo ...done!

lcl-win32-dll: $(LIB_WIN32_OBJS:.obj=.d_obj)
	@-echo Assembling LCL as DLL ...
	@link /warn:3 $(LDFLAGS_COMMON) /nologo $(LIB_WIN32_OBJS:.obj=.d_obj) $(PCRE_STATIC_LIB) /out:lcl_win32.dll /subsystem:windows $(WIN_LIBS) /DLL 
	@-echo ...done!

lcl-win32-lib-debug: $(LIB_WIN32_OBJS:.obj=.sd_obj)
	@-echo Assembling LCL as static LIB (DEBUG Version) ...
	@lib $(LDFLAGS_COMMON) $(LDFLAGS_LIB_DEBUG) $(PCRE_STATIC_DEBUG_LIB) $(LIB_WIN32_OBJS:.obj=.sd_obj) /out:lcl_win32_static_debug.lib
	@-echo ...done!

lcl-win32-dll-debug: $(LIB_WIN32_OBJS:.obj=.dd_obj)
	@-echo Assembling LCL as DLL (DEBUG Version) ...
	@link /warn:3 $(LDFLAGS_COMMON) $(LDFLAGS_DLL_DEBUG) $(PCRE_STATIC_DEBUG_LIB) $(LIB_WIN32_OBJS:.obj=.dd_obj) /out:lcl_win32_debug.dll /subsystem:windows $(WIN_LIBS) /DLL  /MAP /profile
	@-echo ...done!

exe-tst: $(LD_WIN32_OBJ:.obj=.dd_obj) lcl_main.dd_obj
	@-echo Assembling LCL as EXE...
	@link  $(LDFLAGS_COMMON) $(LDFLAGS_DLL_DEBUG) $(PCRE_STATIC_DEBUG_LIB) $(LIB_WIN32_OBJS:.obj=.dd_obj) /out:lcl.exe /subsystem:console $(WIN_LIBS)  /MAP /profile lcl_main.dd_obj
	@-echo ...done!

clean:
	@-del *.obj
	@-del *.dll
	@-del *.lib
	@-del *.d_obj
	@-del *.s_obj
	@-del *.dd_obj
	@-del *.sd_obj

