/* ****************************************************************************
   |      File: lconfobj.cc
   |      Contains: class LConfigObject
   |      Created: 18.03.1998
   |      Last Changed: 19.03.1998
   |      Version: 0.0
   |         
   |      ToDo: + just started
   |
   ************************************************************************* */

/* ************************************************************************* *
 * Change log:                                                               *
 * -------------                                                             *
 *                                                                           *
 *   -> [v0.00] - 18.03.1998 - Created file and started coding               * 
 * ************************************************************************* */


// **** LCL Includes

#include <lcl.h>
#include <lcl/lconfobj.h>
#include <lcl/llogsystem.h>

bool LConfigObject::warn = false;

LConfigObject::LConfigObject ( )
{
}

LConfigObject::LConfigObject ( LString const & _type ) :
  type ( _type )
{
}

LConfigObject::LConfigObject ( LConfigObject const & p1 ) :
  type ( p1.type ),
  dict ( p1.dict )
{
}

LString LConfigObject::get ( LString const & key, LString const & def ) const
{
  /*
  LString value, str(def);
  try {
    value = dict.get ( key );
    str = value;
  }
  catch ( int i ) {
  }
  catch (...) {
    //cout << "#";
    //cout << def.length();
    //cout << "DEFAULTING-" << def;
    //value = def;
    //str = def;
  }
  return str;
  */
  if ( warn ) {
    if ( !dict.isSet ( key ) )
      LLOG ( LLogSystem::WARNING, "Object key '" + key + "' not set. Defaulting to '" + def + "'" );
  }
  return dict.get ( key, def );
}

bool LConfigObject::isSet ( LString const & key ) const 
{
  return dict.isSet ( key );
}

/*!
 * \param _type The new type of the object
 */
void LConfigObject::setType ( LString const & _type )
{
  type = _type;
}

void LConfigObject::set ( LString const & key, LString const & value )
{
  dict.set ( key, value );
}

bool LConfigObject::isOfType ( LString const & _type ) const
{
  return (type == _type);
}

LString LConfigObject::getType () const
{
  return type;
}

/*!
 * \post The object is empty
 */
void LConfigObject::clear ()
{
  dict.clear();
}

LHash<LString,LString> & LConfigObject::getHash ()
{
  return dict;
}

// Currently we don't have a LDictionary::operator==
/*int LConfigObject::operator ==(const LConfigObject & p1)
{
  return (type==p1.type) && (dict == p1.dict);
}*/
