#include <lcl/lconfparser_dir.h>
#include <lcl/ltrace.h>

LVCS_INIT(LDirectoryConfigParser);

#include <lcl/ldirectory.h>

LDirectoryConfigParser::LDirectoryConfigParser ( LString const & _dir ) :
  dir ( _dir )
{
}

void LDirectoryConfigParser::parseHeader ( LConfigSystem * system )
{

  LTRACE ( "LDirectoryConfigParser", "Scanning: " + dir );

  LHeap<LString> fileList ( LDirectory::getFileList ( dir ) );

  LManagedPointer<LCursor> cursor = fileList.createCursor ();

  LTRACE ( "LDirectoryConfigParser", "Found " + LString(fileList.entries()) + " files!" );

  for ( cursor->setToFirst(); cursor->isValid(); cursor->setToNext() )
    {

      LTRACE ( "LDirectoryConfigParser", "Loading: " +  dir + "/" + fileList.elementAt ( cursor ) );

      LDefaultConfigParser * parser = new LDefaultConfigParser ( dir + "/" + fileList.elementAt ( cursor ) );
      parser->parseHeader ( system );
      parser->parseMain ( system );
      delete parser;
      LTRACE ( "LDirectoryConfigParser", "Completed load!" );
    }
}

void LDirectoryConfigParser::parseMain ( LConfigSystem * )
{
}
