#include <lcl/lcursor.h>
#include <malloc.h>

/*!
 * \example cursor.cc
 * This example shows you how to use LCursor
 */

LCursor::LCursor ( LBaseCollection * coll ) :
  collection ( coll )
{
  if ( collection ) {
    collection->addCursor ( this );
  }
}

LCursor::~LCursor ()
{
  if ( collection ) {
    collection->removeCursor ( this );
  }
}

bool LCursor::isFor ( const LBaseCollection * coll ) const
{
  return collection == coll;
}

void LCursor::invalidate ( )
{
  valid = false;
}

void LCursor::obsolete ( )
{
  collection = NULL;
}
