/* -*-mode: c++; coding: iso-8859-2-unix; -*- */

/* LCL - The Linux Class Library
 * Copyright (C) 1998-2003 Jens Reimann
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "lcl/lerrcode.h"

#include <lcl/lstring.h>

LErrorCode::LErrorCode () :
  m_code ( 0L )
{
  strcpy ( m_module, "XXX" );
  strcpy ( m_submodule, "XXX" );
}

LErrorCode::LErrorCode ( LErrorCode const & p1 ) :
  //  m_module ( p1.m_module ),
    //  m_submodule ( p1.m_submodule ),
  m_code ( p1.m_code )
{
  setModule ( p1.m_module );
  setSubModule ( p1.m_submodule );
  //  m_module = (char[16])p1.m_module;
  //  m_submodule = (char[16])p1.m_submodule;
}

//LErrorCode::LErrorCode ( LString const & module, LString const & submodule, luint32 code ) :
LErrorCode::LErrorCode ( char const * module, char const * submodule, luint32 code ) :
  m_code ( code )
{
  setModule ( module );
  setSubModule ( submodule );
}

LErrorCode::~LErrorCode ()
{
}

LErrorCode const & LErrorCode::operator = ( LErrorCode const & p1 )
{
  setModule ( p1.m_module );
  setSubModule ( p1.m_submodule );
  m_code = p1.m_code;

  return *this;
}

void LErrorCode::setModule ( char const * module )
{
  strncpy ( m_module, module, sizeof(m_module)-1 );
  m_module[sizeof(m_module)-1] = 0;
}

void LErrorCode::setSubModule ( char const * submodule )
{
  strncpy ( m_submodule, submodule, sizeof(m_submodule)-1 );
  m_submodule[sizeof(m_submodule)-1] = 0;
}

void LErrorCode::setCode ( luint32 code )
{
  m_code = code;
}

char const * LErrorCode::getModule ( ) const
{
  return m_module;
}

char const * LErrorCode::getSubModule ( ) const
{
  return m_submodule;
}

luint32 LErrorCode::getCode () const
{
  return m_code;
}

char const * LErrorCode::asString () const
{
  //LString tmp = LString::fromPrintf ( 128, "%s-%s-%08X", (char const*)*m_module, (char const*)*m_submodule, m_code );
  //strncpy ( m_asstring, tmp, sizeof(m_asstring)-1 );
  //m_asstring[sizeof(m_asstring)-1] = 0;
  ((char*)m_asstring)[0] = 0;
  sprintf ( (char*)m_asstring, "%s-%s-%08X", (char const*)m_module, (char const*)m_submodule, m_code );
  return m_asstring;
}


