#include <lcl/linterpreter_plugin.h>

#include <lcl/lpluginloader.h>

LInterpreter_PlugIn::LInterpreter_PlugIn ( LString const & fname ) :
  LPlugIn < LInterpreter_PlugIn_Factory, 7 > ( fname )
{
}

/*
void LInterpreter_PlugIn::loadPlugIns ( LInterpreter & inter )
{
  LHeap<LString> list = LDirectory::getList( "/lcl/plugins" );
  LManagedPointer<LCursor> cursor = list.createCursor();

  for ( cursor->setToFirst(); cursor->isValid(); cursor->setToNext() )
    {
      LTRACE ( "LInterpreter_PlugIn", "Loading PlugIn " "/lcl/plugins/" + list.elementAt ( cursor ) );
      LInterpreter_PlugIn * plugin = new LInterpreter_PlugIn ( "/lcl/plugins/" + list.elementAt ( cursor ) );
      if ( plugin->isValid() )
	{
	  LTRACE ( "LInterpreter_PlugIn", "Loaded PlugIn " + plugin->getName() + " -> " + plugin->getDescription() );
	  LInterpreter_PlugIn_Factory * factory = plugin->createObject ();
	  if ( factory )
	    {
	      factory->registerAll ( inter );
	      LTRACE ( "LInterpreter_PlugIn", "Function set loaded" );
	    }
	  else
	    {
	      LTRACE ( "LInterpreter_PlugIn", "Unable to load plugin" );
	    }
	  delete factory;
	  //	  delete plugin;
	}
      else
	{
	  LTRACE ( "LInterpreter_PlugIn", "PlugIn /lcl/plugins/" + list.elementAt ( cursor ) + " is not a valid interpreter command plug-in" );
	  delete plugin;
	}
    }
}
*/

class InterPlugLoader : public LPlugInLoader < LInterpreter_PlugIn > {
protected:
  LInterpreter & inter;

public:

  InterPlugLoader ( LInterpreter & _inter ) :
    inter ( _inter )
  {
  }

  void foundPlugIn ( LInterpreter_PlugIn * plugin )
  {
    LInterpreter_PlugIn_Factory * factory = plugin->createObject ();
    if ( factory )
      {
	factory->registerAll ( inter );
	LTRACE ( "LInterpreter_PlugIn", "Function set loaded" );
      }
    else
      {
	LTRACE ( "LInterpreter_PlugIn", "Unable to load plugin" );
      }
    delete factory;    
  }
};

void LInterpreter_PlugIn::loadPlugIns ( LInterpreter & inter )
{
  InterPlugLoader ipl ( inter );
  ipl.scan ();
}
