#include <lcl/lplugin.h>
#include <lcl/ltrace.h>

LVCS_INIT(LGenericPlugIn);

LGenericPlugIn::LGenericPlugIn ( LString const & fname ) :
  lib ( fname )
{
  memset ( &info, 0, sizeof(info) );

  loadInfo ();
}

bool LGenericPlugIn::isValid () const
{
  return lib.isValid() && (info.module[0] != 0);
}

LString LGenericPlugIn::getName () const
{
  if ( !isValid() )
    return "";

  return info.module;
}

LString LGenericPlugIn::getDescription () const
{
  if ( !isValid() )
    return "";

  return info.description;
}

LString LGenericPlugIn::getGroup () const
{
  if ( !isValid() )
    return "";

  return info.group;
}

void LGenericPlugIn::loadInfo ()
{
  if ( !lib.isValid() )
    {
      LTRACE ( "LGenericPlugIn", "Library not loaded!" );
      return;
    }

  lcl_plugin_info* (*info_proc)(void);

  info_proc = (lcl_plugin_info*(*)(void))lib.getProc ( "lcl_plugin_get_info" );

  if ( info_proc )
    {
      LTRACE ( "LGenericPlugIn", "loading info proc!" );
      info = *(info_proc ( ));
    }
  else
    {
      LTRACE ( "LGenericPlugIn", "info proc not found!" );
    }
}
