#include <lcl/lsigset.h>

LSignalSet::LSignalSet ()
{
  empty ();
}

LSignalSet::LSignalSet ( LSignalSet const & p1 ) :
  set ( p1.set )
{
}

void LSignalSet::empty ()
{
  sigemptyset ( &set );
}

void LSignalSet::fill ()
{
  sigfillset ( &set );
}

bool LSignalSet::isMember ( int signo ) const
{
  return sigismember ( &set, signo );
}

void LSignalSet::add ( int signo )
{
  sigaddset ( &set, signo );
}

void LSignalSet::remove ( int signo )
{
  sigdelset ( &set, signo );
}

LSignalSet::operator sigset_t * ()
{
  return &set;
}

LSignalSet::operator sigset_t const * () const
{
  return &set;
}
