/* -*-mode: c++; coding: iso-8859-2-unix; -*- */

#include <lcl/lstringreplace.h>

// LStringHashReplacer

LStringHashReplacer::LStringHashReplacer ( LHash<LString,LString> const & _hash, bool _caseSens ) :
  hash ( _hash ),
  caseSens ( _caseSens )
{  
}

LStringHashReplacer::~LStringHashReplacer ()
{
}

LString LStringHashReplacer::replace ( LString const & _tag ) const
{
  LString tag;
  if ( caseSens )
    tag = _tag;
  else
    tag = _tag.toUpper ();
  
  if ( !hash.isSet ( tag ) )
    throw TagNotFound();
  
  return hash.get ( tag, "" );
}

// LStringEnvReplacer

LString LStringEnvReplacer::replace ( LString const & tag ) const
{
  LString env = LString::fromEnv ( tag );
  
  if ( !env.length() )
    throw TagNotFound();
    
  return env;
}

LStringEnvReplacer::~LStringEnvReplacer ()
{
}
