#include <lcl/ltimer.h>

LTimer::LTimer ( LTicker & ticker, LString const & name ) :
  m_ticker ( ticker ),
  m_name ( name )
{
}

LTimer::~LTimer ()
{
  tickSlot.disconnect ();
}

void LTimer::ticked ( void )
{
  LTRACEX_FUNC("void LTimer::ticked ( void )" );

  LTRACE ( "LTimer", "difftime: " + LString(difftime(time(0),m_start)) );
  if ( difftime ( time(0), m_start ) > m_timeout )
    {
      unset ();
      expiredNamed.emit ( m_name );
      expired.emit ();
    }
}

void LTimer::set ( luint32 timeout )
{
  LTRACEX_FUNC("void LTimer::set ( luint32 timeout )" );

  m_timeout = timeout;
  m_start = time(0);

  if ( m_timeout )
    {
      tickSlot.disconnect ();
      tickSlot = connect_emitter_0 ( &LTimer::ticked, *this, m_ticker.ticker );
    }
  else
    {      
      tickSlot.disconnect ();
    }
}

void LTimer::unset ( void )
{
  LTRACEX_FUNC("void LTimer::unset ( void )");

  set ( 0 );
}
