#include <lcl/ltracechannel.dgram.h>

#include <lcl/lutils.h>

LTraceChannel_DGRAM::LTraceChannel_DGRAM ( LHash<LString,LString> & params ) :
  socket ( AF_INET, SOCK_DGRAM ),
  valid ( false )
{
  dstAddr = LSockAddr4Inet ( params.get ( "host", "localhost" ) + ":" + params.get ( "port", "1213" ) );
  socket.bind ( LSockAddr4Inet::any() );
}

void LTraceChannel_DGRAM::trace ( const char * module, const char * message )
{
  LTracePacket packet;
  strcpy ( packet.appName, LString(LGetProcessID()) );
  strcpy ( packet.moduleName, module );
  strcpy ( packet.message, message );

  packet.pid = LGetProcessID ();
  packet.tid = (unsigned long)LGetCurrentThreadID ();
  
  socket.sendto ( &packet, sizeof(packet), dstAddr, dstAddr.length() );
}

