#include <lcl/lvcs.h>

#include <malloc.h>
#include <string.h>
#include <iostream.h>
#include <lcl/liostream.h>

//LHeap<LVersionControlObject> LVersionControlObject::vcsList;

//LHeap<LVersionControlObject> vcsList;

LVCS_Struct * vcsList_head = NULL;
LVCS_Struct * vcsList = NULL;

LVersionControlObject::LVersionControlObject ( char const * _className, char const * _timestamp, char const * _filename )
{
  strcpy ( className, _className );
  strcpy ( timestamp, _timestamp );
  strcpy ( filename, _filename );

  if ( !vcsList_head ) {
    vcsList_head = vcsList = (LVCS_Struct*) malloc ( sizeof(LVCS_Struct) );
    vcsList->next = NULL;
    vcsList->vco = *this;
  } else {
    vcsList->next = (LVCS_Struct*) malloc ( sizeof(LVCS_Struct) );
    vcsList = vcsList->next;
    vcsList->next = NULL;
    vcsList->vco = *this;
  }
}

LVersionControlObject::LVersionControlObject ( LVersionControlObject const & p1 )
{
  strcpy ( className, p1.className );
  strcpy ( timestamp, p1.timestamp );
  strcpy ( filename, p1.filename );
}

void LVersionControlObject::dumpAll ( LOStream & ostream )
{

  ostream << "-------------------- LCL Object Version Control system -------------------" << endl;
  LVCS_Struct * vcsEntry = vcsList_head;
  while ( vcsEntry ) {
    ostream << (char const*)vcsEntry->vco.timestamp << (char const*)" | " << (char const*)vcsEntry->vco.filename << (char const*)" | " << (char const*)vcsEntry->vco.className << endl << flush;
    vcsEntry = vcsEntry->next;
  }
  ostream << "--------------------   End of registered object dump   -------------------" << endl;
}

#include <lcl/lrevision.h>

LFEATURE("VersionControl", vc_vcs, "Version Control System" );

LREVISION("VersionControl", vc_feat10, "1.0", "Initial Release" );
