#include <lcl.h>
#include <lcl/lapp.h>
#include <lcl/lmutex.h>
#include <lcl/lthread.h>

LMutex mutexLock;

unsigned long dummy;

// our sample function which should be locked
void func ( void )
{
  LAutoLock lock ( mutexLock );

  // this code is now locked ...

  // ... code ...

  // e.g. modify
  dummy++;

  // it will be unlock here
}

// thread function
void runner ( void )
{
  while ( true )
    {
      sleep ( 1 );
      func ();
    }
}

LFuncThreadFn runnerFn ( runner );

int main ( int argc, char * argv [] )
{

  // typical init code 
  theApp.init ( argc, argv );
  theApp.processLCLParamters ();

  // Create Thread Control Objects
  LThread tco1 ( &runnerFn );
  LThread tco2 ( &runnerFn );

  // start threads ...
  tco1.start ();
  tco2.start ();

  // main loop
  while ( true )
    {
      sleep ( 1 );
    }
}
