include ../Makefile.def.MS

LCL_TST_APPS = dlltst.exe conf.exe env.exe

all: $(LCL_TST_APPS)

CFLAGS_COMMON=/I../include /nologo
CFLAGS_DLL=/MD
CFLAGS_LIB=/MD /DBUILD_STATIC=1
CFLAGS_DLL_DEBUG=/MDd /Zi
CFLAGS_LIB_DEBUG=/MDd /Zi /DBUILD_STATIC=1

CXXFLAGS_COMMON=/I../include /GX /GR /nologo /Zm150
CXXFLAGS_DLL=/MD
CXXFLAGS_LIB=/MD /DBUILD_STATIC=1
CXXFLAGS_DLL_DEBUG=/MDd /Zi /DENABLE_DEBUG=1
CXXFLAGS_LIB_DEBUG=/MDd /Zi /DBUILD_STATIC=1 /DENABLE_DEBUG=1

LDFLAGS_COMMON=/nologo
LDFLAGS_DLL=
LDFLAGS_LIB=
LDFLAGS_DLL_DEBUG=
LDFLAGS_LIB_DEBUG=

.obj.exe:
	link /out:$@ $<

cmdline.exe: maincmdline.dd_obj
	link /debug /out:$@ $** ../lib/lcl_win32_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

str32.exe: mainstr32.dd_obj
	link /debug /out:$@ $** ../lib/lcl_win32_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

segv.exe: mainsegv.dd_obj
	link /debug /out:$@ $** ../lib/lcl_win32_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

chargen.exe: mainchargen.dd_obj
	link /debug /out:$@ $** ../lib/lcl_win32_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

xcpt.exe: mainxcpt.dd_obj
	link /debug /out:$@ $** ../lib/lcl_win32_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

time.exe: maintime.dd_obj
	link /debug /out:$@ $** ../lib/lcl_win32_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

trace.exe: maintrace.dd_obj
	link /debug /out:$@ $** ../lib/lcl_win32_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

liccrypt.exe: crypt_main.d_obj
	link /out:$@ $** ../lib/lcl_win32.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

event.exe: mainevent.dd_obj
	link /out:$@ $** ../lib/lcl_win32_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

queue.exe: mainqueue.dd_obj
	link /out:$@ $** ../lib/lcl_win32_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

markus.exe: mainmarkus.dd_obj
	link /subsystem:console /out:$@ $** ../lib/lcl_win32_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

ticker.exe: mainticker.dd_obj
	link /out:$@ $** ../lib/lcl_win32_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

variant.exe: mainvariant.dd_obj  lcl_test.dd_obj
	link /out:$@ $** ../lib/lcl_win32_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib	/debug

script.exe: mainscript.dd_obj
	link /out:$@ $** ../lib/lcl_win32_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

emitx.exe: mainemitx.sd_obj ../lib/lemitx.sd_obj
	link /debug /out:$@ $** ../lib/lcl_win32_static_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

iobuf.exe: mainiobuf.dd_obj
	link /debug /out:$@ $** kernel32.lib user32.lib ws2_32.lib advapi32.lib ../lib/lcl_win32_debug.lib

appsrv.exe: appsrv.dd_obj app_connection.dd_obj app_baseclass.dd_obj app_connmgr.dd_obj app_remoteconn.dd_obj app_nodemgr.dd_obj
	link /debug /out:$@ $** ../lib/lcl_win32_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

appctrl.exe: mainappctrl.dd_obj
	link /map /profile /debug /out:$@ $** ../lib/lcl_win32_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

env.exe: mainenv.dd_obj
	link /debug /out:$@ $** ../lib/lcl_win32_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

http_plug_1.dll: http_plug_1.d_obj
	link /release /out:http_plug_1.dll http_plug_1.d_obj ../lib/lcl_win32.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib /DLL

http_plug_app.dll: http_plug_app.d_obj
	link /release /out:http_plug_app.dll http_plug_app.d_obj ../lib/lcl_win32.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib /DLL

httpd.exe: mainhttpd.d_obj
	link /release /out:httpd.exe mainhttpd.d_obj ../lib/lcl_win32.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

select.exe: mainselect.sd_obj
	link /debug /out:select.exe mainselect.sd_obj ../lib/lcl_win32_static_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

regex.exe: mainregex.dd_obj
	link /debug /out:regex.exe mainregex.dd_obj ../lib/lcl_win32_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

reg32.exe: mainreg.sd_obj
	link /debug /out:reg32.exe mainreg.sd_obj ../lib/lcl_win32_static_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

conf.exe: mainconf.sd_obj
	link /debug /out:conf.exe mainconf.sd_obj ../lib/lcl_win32_static_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

str.exe: mainstr.dd_obj lcl_test.dd_obj
	link  /debug /out:$@ $** ../lib/lcl_win32_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

dir.exe: maindir.sd_obj
	link /debug /out:dir.exe maindir.sd_obj ../lib/lcl_win32_static_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

fd32sel.exe: mainfd32sel.sd_obj ../lib/lcl_win32_static_debug.lib
	link /out:fd32sel.exe mainfd32sel.sd_obj ../lib/lcl_win32_static_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

dlltst.exe: maindll.d_obj
	link /out:dlltst.exe maindll.d_obj ../lib/lcl_win32.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib

inter2.exe: maininter2.dd_obj
	link /out:$@ $** ../lib/lcl_win32_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib /debug

lpll.tab.c: lpll.y
	bison -d -y lpll.y

lpll.yy.c: lpll.tab.c lpll.l
	flex -olpll.yy.c lpll.l

lpll.exe: lpll.tab.dd_obj lpll.yy.dd_obj
	link  /debug /out:$@ $** ../lib/lcl_win32_debug.lib kernel32.lib user32.lib ws2_32.lib advapi32.lib
