/* -*-mode: c++; coding: iso-8859-2-unix; -*- */

#include <lcl.h>
#include <lcl/lconfsys.h>
#include <lcl/literator.h>
#include <lcl/lapp.h>
#include <lcl/lstreamproxy.h>
#include <lcl/lconfmodule.h>
#include <lcl/lconfparser_dir.h>
#include <lcl/lconfmodule_tcl.h>
#include <lcl/llogsystem.h>

using namespace std;

class ListFiles : public LIterator<LConfigObject> {
public:
  virtual void applyTo (LConfigObject & obj ) {
    lout << "Found object:\n";
    lout << obj.get("name") << "\n";
  };
};

void list ( LConfigObject & obj, void * ptr )
{
  lout << "List: " << obj.get ( "name", "<none>" ) << endl;
}

int main (int argc, char * argv[])
{

  theApp.init ( argc, argv );
  theApp.processLCLParameters ();

  LLOG ( LLogSystem::INFO, "LOG Test!" );

  lout << "Reading config file tst.conf:" << endl << flush;

  LConfigSystem conf ( LConfigReader_default ( "tst.conf" ) );  
  //LConfigSystem conf ( new LDefaultConfigParser ( "tst.conf" ) );  
//  LConfigSystem conf ( new LDirectoryConfigParser ( "conf.d" ) );

  lout << "Number of 'files': " << conf.count("files") << "\n";

  lout << "----------------------------\n";
  ListFiles listFiles;
  conf.forEachType ( "files", listFiles );
  conf.forEach( list, NULL );

  lout << conf.firstObjectWithMemberEqual ( "files", "name", "test" ).get ( "size" )  << endl;

  lout << "Check for files->name == test  : ";
  if ( conf.containsObjectWithMemberEqual ( "files", "name", "test" ) )
    lout << "yes" << endl;
  else
    lout << "no" << endl;

  lout << "Check for files->name == test2_  : ";
  if ( conf.containsObjectWithMemberEqual ( "files", "name", "test2_" ) )
    lout << "yes" << endl;
  else
    lout << "no" << endl;

  lout << endl;

  LConfigWriter_default cw ( lout );
  cw.write ( conf );

  conf.clear ();

  LTable<LString> ref_cmd1 ( 3 );
  ref_cmd1[0] = "FIELD1";
  ref_cmd1[1] = "FIELD2";
  ref_cmd1[2] = "FIELD3";

  LHash < LString, LTable<LString> > ref;
  ref.set ( "cmd1", ref_cmd1 );

  LConfigReader_TCL tcl_reader ( ref, "test_conf.tcl" );
  tcl_reader.read ( conf );

  lout << "------------ TCL OUTPUT ----------" << endl;

  LConfigWriter_TCL tcl_writer ( ref, lout );
  tcl_writer.write ( conf );

  lout << "------------ TCL OUTPUT ----------" << endl;

  cw.write ( conf );

  lout << "------------ TCL OUTPUT ----------" << endl;


  return 0;
}
