#include <ldbsystem.h>
#include <lapp.h>

using namespace std;

int main ( int argc, char * argv[] )
{
  cout << "LDBSystem Test v0.2\n";

  theApp.init ( argc, argv );
  theApp.processLCLParameters ();

  if ( !theApp.hasParam ( "d" ) ) {
    cout << "\nSyntax: " << argv[0] << " -d \"lcl-db-uri\"" << endl;
    return 1;
  }

  LDBDriver * driver = openDatabase ( theApp.getParam("d") );
  if ( !driver ) {
    cout << "Error opening database: " << theApp.getParam("d") << endl;
    return 1;
  }
  if ( !driver->connected() ) {
    cout << "Error opening database: " << theApp.getParam("d") << endl;
    return 1;    
  }

  int i;
  bool quit = false ;
  LManagedPointer<LDBQuery>  query;
  char buffer[1024];

  while ( !quit ) {
    cout << " -> ";
    cin.getline ( buffer, sizeof(buffer) );
    if ( LString(buffer) == "\\quit" )
      quit = true;
    
    if ( buffer[0] != '\\' && buffer[0] != 0 ) {
      query = driver->query ( buffer );
      if ( query.isValid() && query->isValid() ) {
	
	cout << "Query OK";
	cout << endl;
	cout << "Return fields: " << query->numFields() << endl;
		
        for ( i = 0; i<query->numFields(); i++ ) {
	   cout << query->getFieldName ( i ) << "  "; 
        }
	cout << endl;
	while ( query->fetchNext() ) {

	  for ( i = 0; i<query->numFields(); i++ ) {
	    cout << query->getField ( i ) << " -- ";
	  }
	  cout << endl;

	}

	//delete query;
      } else {
	cout << "Query failed!" << endl;
      }
    }
  }

  delete driver;
  return 0;
}
