#include <lcl/lparser.h>
#include <lcl/linterpreter_commands.h>
#include <lcl/linterpreter_plugin.h>

#include <lcl/lstreamproxy.h>
#include <lcl/lapp.h>

int main ( int argc, char * argv[] )
{
  theApp.init ( argc, argv );
  theApp.processLCLParameters ();

  try
    {
    LParser_LSLL parser;
    LInterpreter inter;

    LCommands::Base::registerAll ( inter );
    LCommands::String::registerAll ( inter );
    LCommands::Time::registerAll ( inter );
    //    LCommands::Win32::registerAll ( inter );

    LInterpreter_PlugIn::loadPlugIns ( inter );

    LString cmd;
    LBuffer tmp(32);
    try
      {
	while ( 1 )
	  {
	    int rc = lin.read ( tmp, 16 );
	    tmp.resize ( rc );
	    cmd += LString(tmp);
	  }
      }
    catch ( LEndOfStreamException & c )
    {
      tmp.resize ( c.nData );
      cmd += LString(tmp);
      lerr << endl << "End" << endl;
    }
    
    
    LManagedPointer<LInterpreter::Sequence> seq = parser.parse ( cmd );
    if ( !seq.isValid() )
      {
	lout << "Invalid command!" << endl;
	exit ( 1 );
      }
    lout << "Result: " << inter.run ( seq ) << endl;
    }
  catch ( LBasicException & e )
    {
      e.log ();
    }
  catch ( const char * str )
    {
      lout << "Err: " << str << endl;
    }
  catch ( int i )
    {
      lout << "Int error: " << i << endl;
    }
  catch ( ... )
    {
      lout << "Unkown error!" << endl;
    }
  return 0;
}
