#ifdef _WIN32

#include <lcl/linterpreter.h>
#include <lcl.h>

_BASE_COMMAND_DEFINE(win32_MessageBox);

#include <lcl/linterpreter_plugin.h>


class Win32Commands_Factory : public LInterpreter_PlugIn_Factory {
protected:
public:
  virtual void registerAll ( LInterpreter & inter );
};

void Win32Commands_Factory::registerAll ( LInterpreter & inter )
{
  _BASE_COMMAND_REGISTER(win32_MessageBox);
}

_BASE_COMMAND_CONSTRUCTOR_ALT (win32_MessageBox, "MessageBox" )
_BASE_COMMAND_BODY_START (win32_MessageBox)
{
  LString flags;
  unsigned int mb_button, mb_icon, mb_def, mb_modal;
  
  mb_button = mb_icon = mb_def = mb_modal = 0;
  
  if ( args.getSize() == 3 )
    {
      flags = args[2];
      int i;
      for ( i = 0; i<flags.numWords(); i++ )
	{
	  LString tmp = flags.word(i).toUpper();
	  if ( tmp == "OK" )
	    {
	      mb_button = MB_OK;
	    }
	  else if ( tmp == "OKCANCEL" )
	    {
	      mb_button = MB_OKCANCEL;
	    }
	  else if ( tmp == "RETRYCANCEL" )
	    {
	      mb_button = MB_RETRYCANCEL;
	    }
	  else if ( tmp == "YESNO" )
	    {
	      mb_button = MB_YESNO;
	    }
	  else if ( tmp == "YESNOCANCEL" )
	    {
	      mb_button = MB_YESNOCANCEL;
	    }
	  else if ( tmp == "WARNING" )
	    {
	      mb_icon = MB_ICONWARNING;
	    }
	  else if ( tmp == "ERROR" )
	    {
	      mb_icon = MB_ICONERROR;
	    }
	  else if ( tmp == "INFORMATION" )
	    {
	      mb_icon = MB_ICONINFORMATION;
	    }
	  else if ( tmp == "QUESTION" )
	    {
	      mb_icon = MB_ICONQUESTION;
	    }
	  else if ( tmp == "DEF1" )
	    {
	      mb_def = MB_DEFBUTTON1;
	    }
	  else if ( tmp == "DEF2" )
	    {
	      mb_def = MB_DEFBUTTON2;
	    }
	  else if ( tmp == "DEF3" )
	    {
	      mb_def = MB_DEFBUTTON3;
	    }
	  else if ( tmp == "DEF4" )
	    {
	      mb_def = MB_DEFBUTTON4;
	    }
	  else if ( tmp == "APPMODAL" )
	    {
	      mb_modal = MB_APPLMODAL;
	    }
	  else if ( tmp == "SYSMODAL" )
	    {
	      mb_modal = MB_SYSTEMMODAL;
	    }
	  else if ( tmp == "TASKMODAL" )
	    {
	      mb_modal = MB_TASKMODAL;
	    }
	}
    }
  return ::MessageBox ( NULL, args[1], args[0], mb_button | mb_icon | mb_def | mb_modal );
}    
_BASE_COMMAND_BODY_END ( win32_MessageBox );


LCL_PLUGIN_INIT("Win32", "Win32 commands for LCL interpreter", 7);
LCL_PLUGIN_FACTORY(Win32Commands_Factory);

#endif
